shift <-
function(series1, series2, ages.1, ages.2, n.age.1, n.age.2) {
	path=.path.package("TimeShift")
	## Align series2 to series1 age scales

	### expression matrix of series1 and series2 ###########
	series1=series1
	series2=series2

	### total number of genes #######
	n=nrow(series1)

	##### real ages of series1 and series2#####
	ages.1=ages.1
	ages.2=ages.2

	####  interpolated ages of series1 and series2#####
	n.age.1<-n.age.1
	n.age.2<-n.age.2

	###### number of interpolated ages of series1 and series2 #####
	N=length(n.age.1)
	M=length(n.age.2)

	###  predict the expression levels of series1 and series2 by the interpolated ages########
	d.f=4
	ph=matrix(0,ncol=N,nrow=n)
	for(i in 1:n)
	{  dd=smooth.spline(ages.1,series1[i,],df=d.f)
		ph[i,]=predict(dd,n.age.1)$y
	}

	pc=matrix(0,ncol=M,nrow=n)
	for(i in 1:n)
	{  dd=smooth.spline(ages.2,series2[i,],df=d.f)
		pc[i,]=predict(dd,n.age.2)$y
	}

	write.table(ph,paste(path,"/data/series1.txt",sep=""),col.names=F,row.names=F,sep=" ")
	write.table(pc,paste(path,"/data/series2.txt",sep=""),col.names=F,row.names=F,sep=" ")

	cmd = paste('g++ ',path,'/data/dtw.cpp -o ',path,'/data/dtw',sep='')
	cmd.value = system(cmd)
	if(cmd.value != 0) stop("Cannot compile dtw.cpp!")
	cmd = paste(path,'/data/dtw ',path,'/data/series1.txt ',path,'/data/series2.txt ', N, ' ', M, ' > ',path,'/data/hc.txt', sep='')
	cmd.value = system(cmd)
	if(cmd.value != 0) stop("dtw was not running as expected!")


	######  read hc.txt to produce shifts

	po=readLines(paste(path,"/data/hc.txt",sep=''))

	## l should be equal to 2*n
	l=length(po)/2

	age.1=c()
	age=c()

	n.age.sp1=n.age.1
	n.age.sp2=n.age.2

	n.sp1=length(n.age.1)=N
	n.sp2=length(n.age.2)=M

	for(i in seq(1,2*l,2))
	{    	 
		 x=as.numeric(unlist(strsplit(po[i],split=" ")))
		 y=as.numeric(unlist(strsplit(po[i+1],split=" ")))
		
		for(k in 1:n.sp2)
		{  p=which(y==k)
			if(length(p)==1)  age.1[k]=n.age.sp1[x[p]]
			if(length(p)>1)  age.1[k]=mean(n.age.sp1[x[p]])
		}
		age=rbind(age,age.1)
	}
		
		
	sh<-c()
	for(i in 1:n)
	{
		sh<-rbind(sh,age[i,]-n.age.sp2)
	}

	return(sh)

}

